//{$WARNINGS OFF}
{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  TExcelApplicationɂGNZ̃`[g(Ot)쐬
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2007N0318 `
//  2014N0112 ŏIXV
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE Pro + Excel 2010
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Excel2000, OleServer;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    ExcelApplication1: TExcelApplication;
    ExcelWorksheet1: TExcelWorksheet;
    ExcelWorkbook1: TExcelWorkbook;
    OpenDialog1: TOpenDialog;
    Button3: TButton;
    Button4: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private 錾 }
    procedure BookOpen(ABookName: String);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

const
  LCID: DWORD = LOCALE_SYSTEM_DEFAULT;

{$R *.DFM}

//=============================================================================
//  GNZɉBȂ悤ɂFormɍőOʂ̉Eɕ\悤ɂ
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  FormStyle := fsStayOnTop;
  Self.Left := Screen.PrimaryMonitor.Width - Self.Width;
  Self.Top  := Screen.PrimaryMonitor.Top;
end;

//=============================================================================
//  Form鎞̓GNZ̏Is
//
//  ԂDisconnect.TExcelApplicationQuitKv.
//  Workbook,WorkSheetIuWFNg𐶐Ăꍇ͂Close
//  DisconnectKv.
//=============================================================================
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if ExcelApplication1.Application.Visible[LCID] then begin
     ExcelWorksheet1.Disconnect;
     ExcelWorkbook1.Close(False,EmptyParam);
     Application.ProcessMessages;
     ExcelWorkbook1.Disconnect;
   end;
   ExcelApplication1.Quit;
   ExcelApplication1.Disconnect;
end;

//=============================================================================
//  ubNJ
//  t@CI[v_CAOgpđI
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  EFile: String;
begin
  //JΏۂ̓GNZ̃ubN
  OpenDialog1.Filter := 'ExcelubN (*.xls)|*.xls';
  //tH_͋NtH_
  OpenDialog1.InitialDir := ExtractFileDir(Application.ExeName);
  if OpenDialog1.Execute then begin
    EFile := OpenDialog1.FileName;
    BookOpen(EFile);
  end;
end;

//=============================================================================
//  GNZďI
//=============================================================================
procedure TForm1.Button2Click(Sender: TObject);
begin
  Close;
end;

//=============================================================================
//  ubNJ\bh
//  JSheet1ANeBuɂ
//=============================================================================
procedure TForm1.BookOpen(ABookName: String);
var
  objExcelApp : OleVariant;
begin
  //\XV~
  ExcelApplication1.ScreenUpdating[LCID] := False;

  if ExcelApplication1.Application.Visible[LCID] then begin
    //݂̃V[gƃubNDisconnect
    ExcelWorksheet1.Disconnect;
    ExcelWorkbook1.Close(False, EmptyParam, False,LCID);
  end;
  ExcelWorkbook1.Disconnect;

  //ubNJWorkbook,WorkSheetɐڑ
  //Open\bḧ͑̂ŁCȗ邽߂OleVariant^ň̂Ƃ
  objExcelApp := ExcelApplication1.Application;
  objExcelApp.Workbooks.Open(FileName := ABookName);

  ExcelWorkbook1.ConnectTo(ExcelApplication1.ActiveWorkbook as _workbook);
  ExcelWorksheet1.ConnectTo(ExcelWorkbook1.Worksheets['Sheet1'] as _Worksheet);
  ExcelWorksheet1.Activate;

  //IɕۑmF_CAO\Ȃ
  ExcelApplication1.DisplayAlerts[LCID] := False;

  //\XVJn
  ExcelApplication1.ScreenUpdating[LCID] := True;
  ExcelApplication1.Visible[LCID] := True;
end;

//=============================================================================
//  `[g(Ot)̍쐬
//=============================================================================
procedure TForm1.Button3Click(Sender: TObject);
var
  ExcelHandle : HWND;
  ARange      : ExcelRange;
  objChart    : Excel2000._Chart;
begin
  ExcelHandle := FindWindow('XLMAIN', nil);
  LockWindowUpdate(ExcelHandle);

  //`[g(Ot)쐬
  ExcelApplication1.Charts.Add(EmptyParam, EmptyParam, 1, EmptyParam, LCID);
  //f[^͈(ڂƌn񃉃x܂)
  ARange := ExcelWorksheet1.Range['A1', 'C4'];

  //쐬΂̎_ł͂̃OtActiveD̃OtSheet1ɕ\
  objChart := ExcelApplication1.ActiveChart.Location(xlLocationAsObject, 'Sheet1');
  objChart.ChartWizard(
                ARange,           //Otf[^͈̔
                xlColumn,         //Ot̎
                EmptyParam,       //g݃I[gtH[}bg̃IvVԍ
                xlColumns,        //f[^n̕DxlRows܂xlColumns
                1,                //f[^͈͂̍ڃx̍s܂͗
                1,                //f[^͈͂̌n񃉃x̍s܂͗
                True,             //}\ɂTrue
                'OtTv', //Ot̃^Cg
                'i',         //ڎ̃^Cg
                'oא',         //l̃^Cg
                EmptyParam,       //3-Dn񎲂܂2-D̑2l̃^Cg
                LCID
                );

  LockWindowUpdate(0);
end;

//=============================================================================
//  낢둀
//  eXĝChartObjectƁCActiveChart̗gpĂ݂
//=============================================================================
procedure TForm1.Button4Click(Sender: TObject);
var
  ExcelHandle   : HWND;
  AChart        : ChartObject;
  objChart      : Excel2000._Chart;
  objCollection : OleVariant;
begin
  ExcelHandle := FindWindow('XLMAIN', nil);
  LockWindowUpdate(ExcelHandle);
  //`[gIuWFNg̑I
  AChart := ExcelWorksheet1.ChartObjects('Ot 1') as ChartObject;

  //\ʒuύX(l̓|CgP)
  AChart.Left   := 20;
  AChart.Top    := 100;
  AChart.Width  := 400;
  AChart.Height := 300;
  AChart.Activate;

  objChart := ExcelApplication1.ActiveChart;
  objChart.PlotArea[LCID].Top := 20;
  //vbg̈̔wixlNone
  objChart.PlotArea[LCID].Interior.ColorIndex:=xlNone;
  //Ŝ̃tHgTCY12pt
  objChart.ChartArea[LCID].Font.Size := 12;
  //Ot̃^Cg20pt
  objChart.ChartTitle[LCID].Font.Size := 20;

  //_Ot̐FύX
  objCollection := objChart.SeriesCollection(1, LCID);
  objCollection.Interior.ColorIndex := 35;
  objCollection := objChart.SeriesCollection(2, LCID);
  objCollection.Interior.ColorIndex := 15;

  LockWindowUpdate(0);
end;

end.
